cadquery/notebook_nueva/modelo.py

209 lines
5.1 KiB
Python
Raw Normal View History

2023-02-17 14:32:01 -03:00
import cadquery as cq
from cadquery import exporters
2023-04-01 18:46:35 -03:00
from cq_warehouse.drafting import Draft
2023-02-16 14:57:32 -03:00
import audio_plug
2023-02-16 14:57:32 -03:00
import battery_holder
2023-03-30 10:24:33 -03:00
import hdmi_out
import keyboard
import screen_pillars
import usb_hub
import zero_holder as cpu_holder
import dimensions as dim
# Base for the notebook. Basically a kbd base that extends back
# as much as possible
screen_pillars.init(dim.mounting_pillar_positions, dim.base_thickness - dim.shell_t)
2023-02-22 18:17:02 -03:00
2023-02-16 14:42:31 -03:00
2022-11-15 15:24:45 -03:00
def model():
# Create the basic shape of the case bottom.
model = (
2022-11-15 15:24:45 -03:00
cq.Workplane("XY")
.workplane(offset=dim.base_thickness / 2)
2022-11-15 15:24:45 -03:00
.tag("mid_height")
# Hollow box
.box(dim.width, dim.height, dim.base_thickness)
2022-11-15 15:24:45 -03:00
.edges("|Z")
.fillet(2)
.faces(">Z")
.shell(-dim.shell_t)
2022-11-15 15:24:45 -03:00
)
# Now the basic box shape is in place, start adding things
# and cutting holes.
2023-03-20 15:04:19 -03:00
model = usb_hub.add(
model=model,
width=dim.width,
height=dim.height,
thickness=dim.base_thickness,
2023-03-20 15:04:19 -03:00
bottom_face="<Z",
back_face=">Y",
offset_x=dim.usb_offset_x,
2023-03-20 15:04:19 -03:00
offset_y=0,
shell_t=dim.shell_t,
2023-03-20 15:04:19 -03:00
)
# Hole for audio in right side
2023-03-20 13:19:14 -03:00
model = audio_plug.add(
model=model,
width=dim.width,
height=dim.height,
thickness=dim.base_thickness,
offset_x=dim.width - audio_plug.item_w,
offset_y=19,
2023-04-01 14:26:48 -03:00
bottom_face="<Z",
2023-03-20 13:19:14 -03:00
back_face=">X",
shell_t=dim.shell_t,
2023-03-20 13:19:14 -03:00
)
2023-03-30 10:24:33 -03:00
# Hole for HDMI out in the back
model = hdmi_out.add(
model=model,
width=dim.width,
height=dim.height,
thickness=dim.base_thickness,
2023-04-15 17:55:26 -03:00
offset_x=dim.hdmi_out_offset_x,
2023-03-30 10:24:33 -03:00
offset_y=0,
bottom_face=None,
back_face=">Y",
shell_t=dim.shell_t,
2023-03-30 10:24:33 -03:00
)
model = cpu_holder.add(
model=model,
width=dim.width,
height=dim.height,
thickness=dim.base_thickness,
offset_x=dim.cpu_offset_x,
offset_y=dim.cpu_offset_y,
bottom_face="<Z",
2023-03-15 10:46:36 -03:00
back_face=None, # Not exposing the holes
shell_t=dim.shell_t,
)
# This adds all the holes and extrusions for the battery system
model = battery_holder.add(
model=model,
width=dim.width,
height=dim.height,
thickness=dim.base_thickness,
offset_x=dim.battery_offset_x,
offset_y=dim.battery_offset_y,
bottom_face="<Z",
back_face=">Y",
shell_t=dim.shell_t,
)
model = screen_pillars.add(
model=model,
width=dim.width,
height=dim.height,
thickness=dim.base_thickness,
offset_x=0,
offset_y=0,
bottom_face="<Z",
back_face=None,
shell_t=dim.shell_t,
)
model = keyboard.add(
model=model,
width=dim.width,
height=dim.height,
thickness=dim.base_thickness,
bottom_face="<Z",
back_face=None,
offset_x=dim.shell_t,
offset_y=dim.kbd_height + dim.shell_t,
shell_t=dim.shell_t,
)
return model
2022-11-15 16:01:20 -03:00
if __name__ == "__main__":
model = model()
left_cutout = cq.Sketch().polygon(
[
(0, 0),
(dim.width / 2, 0),
(dim.width / 2, -dim.height),
(0, -dim.height),
(0, 0),
],
mode="a",
)
right_side = (
model.faces("<Z")
.workplaneFromTagged("mid_height")
.transformed(offset=cq.Vector(0, 0, -dim.base_thickness / 2))
.center(-dim.width / 2, dim.height / 2)
.placeSketch(left_cutout)
.cutBlind(100)
)
exporters.export(right_side, "right_side.stl")
right_cutout = cq.Sketch().polygon(
[
(dim.width / 2, 0),
(dim.width, 0),
(dim.width, -dim.height),
(dim.width / 2, -dim.height),
(dim.width / 2, 0),
],
mode="a",
)
left_side = (
model.faces("<Z")
.workplaneFromTagged("mid_height")
.transformed(offset=cq.Vector(0, 0, -dim.base_thickness / 2))
.center(-dim.width / 2, dim.height / 2)
.placeSketch(right_cutout)
.cutBlind(100)
)
exporters.export(left_side, "left_side.stl")
# draft = Draft(decimal_precision=1)
# dimensions = []
# dimensions.append(
# draft.extension_line(
# object_edge=[
# cq.Vertex.makeVertex(-width / 2, -height / 2, 0),
# cq.Vertex.makeVertex(width / 2, -height / 2, 0),
# ],
# offset=10.0,
# )
# )
# dimensions.append(
# draft.extension_line(
# object_edge=[
# cq.Vertex.makeVertex(width / 2, -height / 2, 0),
# cq.Vertex.makeVertex(width / 2, height / 2, 0),
# ],
# offset=10.0,
# )
# )
2023-04-01 18:46:35 -03:00
exporters.export(model, "model.stl")
2023-04-01 18:46:35 -03:00
# for d in dimensions[1:]:
# dimensions[0].add(d.toCompound())
# dimensions[0].add(model)
2023-04-01 18:46:35 -03:00
exporters.export(
# model[0].toCompound(),
model,
2023-04-01 18:46:35 -03:00
"model.svg",
opt={
"projectionDir": (0, 0, 1),
"strokeWidth": 0.3,
},
)